<template>
  <div>
    <a-card :bordered="false" v-if="visible">
      <div class="table-operator" v-if="!viewFlag">
        <a-button v-if="$auth('purchase-purchase-payments-add')" type="primary" icon="plus" @click="handleAdd">新增</a-button>
      </div>

      <s-table
        ref="table"
        size="small"
        rowKey="id"
        :columns="columns"
        :data="loadData"
        :alert="options.alert"
        :rowSelection="options.rowSelection"
        :scroll="{x: 1, y: BaseTool.Constant.scrollY }"
        showPagination="auto"
      >
        <span slot="action" slot-scope="record">
          <template>
            <a @click="handleView(record)">查看</a>
            <!--            <operation-button-->
            <!--              v-if="$auth('purchase-purchase-payments-edit') && user.userId === record.executorId"-->
            <!--              @click="handleEdit(record)"-->
            <!--            >修改</operation-button>-->
            <operation-button
              v-if="$auth('purchase-purchase-payments-del') && user.userId === record.executorId && !viewFlag"
              :type="2"
              title="是否要删除该条数据？"
              @confirm="batchDelete(record.id)">删除</operation-button>
          </template>
        </span>
      </s-table>
      <base-form ref="baseModal" @ok="handleOk"/>
      <detail ref="detailModal"/>
    </a-card>
  </div>
</template>

<script>
import { STable, Ellipsis } from '@/components'
import BaseForm from './modules/BaseForm'
import Detail from './modules/Detail'
import { getPurchasePaymentOrderPage, deletePurchasePaymentOrders, fetchPurchasePaymentOrder, exportPurchasePaymentOrder } from '@/api/purchase/purchase-payment-order'
import { fetchPurchasePayment } from '@/api/purchase/purchase-payment'
import DetailList from '@/components/tools/DetailList'
const DetailListItem = DetailList.Item
export default {
  name: 'PurchasePaymentOrderList',
  components: {
    STable,
    Ellipsis,
    BaseForm,
    DetailList,
    DetailListItem,
    Detail
  },
  data () {
    return {
      // 查询参数
      queryParam: {
        pageSize: 9999
      },
      visible: false,
      user: this.$store.getters.userInfo,
      isCreated: false,
      paymentId: '-1',
      // 表头
      columns: [
        {
          title: '序号',
          dataIndex: 'index',
          checked: true,
          width: 70,
          customRender: (text, record, index) => {
            return `${index + 1}`
          }
        },
        {
          title: '采购单号',
          dataIndex: 'purchaseOrderNo',
          checked: true,
          width: 200
        },
        {
          title: '供应商名称',
          dataIndex: 'supplierName',
          checked: true,
          width: 150
        },
        {
          title: '付款金额',
          dataIndex: 'money',
          checked: true,
          width: 100,
          customRender: (text, record, index) => {
            return this.BaseTool.Amount.formatter(text)
          }
        },
        {
          title: '付款金额(按照记账主币)',
          dataIndex: 'accountMoney',
          checked: true,
          width: 120,
          customRender: (text, record, index) => {
            return this.BaseTool.Amount.formatter(text) + this.BaseTool.Number.divForDollar(text, record.dollarExchangeRate, 2)
          }
        },
        {
          title: '币种',
          dataIndex: 'moneyType',
          checked: true,
          width: 100,
          customRender: (text, record, index) => {
            return this.BaseTool.Table.getMapText(this.moneyTypeMap, text)
          }
        },
        {
          title: '付款事由',
          dataIndex: 'item',
          checked: true,
          width: 150,
          customRender: (text, record, index) => {
            return this.BaseTool.Table.getMapText(this.itemMap, text)
          }
        },
        {
          title: '合同编号',
          dataIndex: 'contractNo',
          checked: true,
          width: 200
        },
        {
          title: '汇率',
          dataIndex: 'exchangeRate',
          checked: true,
          width: 100,
          customRender: (text, record, index) => {
            return this.BaseTool.Amount.formatter(text)
          }
        },
        {
          title: '备注',
          dataIndex: 'remark',
          checked: true,
          width: 120
        },
        {
          title: '操作',
          key: 'action',
          width: '200px',
          checked: true,
          fixed: 'right',
          align: 'center',
          scopedSlots: { customRender: 'action' }
        }
      ],
      // 下拉框map
      itemMap: {},
      moneyTypeMap: {},
      // 加载数据方法 必须为 Promise 对象
      loadData: parameter => {
        parameter = {
          ...parameter,
          paymentId: this.paymentId,
          ...this.queryParam,
          dataScope: {
            sortBy: 'desc',
            sortName: 'update_time'
          }
        }
        return getPurchasePaymentOrderPage(Object.assign(parameter, this.queryParam))
          .then(res => {
            return res.data
          })
      },
      selectedRowKeys: [],
      selectedRows: [],

      options: {
        alert: { show: true, clear: () => { this.selectedRowKeys = [] } },
        rowSelection: {
          selectedRowKeys: this.selectedRowKeys,
          onChange: this.onSelectChange
        }
      },
      optionAlertShow: false
    }
  },
  created () {
    // 下拉框map
    this.itemMap = this.DictCache.getLabelByValueMapByType(this.DictCache.TYPE.PAY_ITEM)
    this.moneyTypeMap = this.DictCache.getLabelByValueMapByType(this.DictCache.TYPE.MONEY_TYPE)
    this.tableOption()
  },
  props: {
    viewFlag: {
      type: Boolean,
      default: false
    }
  },
  methods: {
    base (id) {
      this.visible = true
      this.paymentId = id
      if (this.isCreated) {
        this.handleOk()
      } else {
        this.tableOption()
        this.isCreated = true
      }
    },
    tableOption () {
      if (!this.optionAlertShow) {
        this.options = {
          alert: { show: true, clear: () => { this.selectedRowKeys = [] } },
          rowSelection: {
            selectedRowKeys: this.selectedRowKeys,
            onChange: this.onSelectChange,
            getCheckboxProps: record => ({
              props: {
                disabled: false,
                name: record.id
              }
            })
          }
        }
        this.optionAlertShow = true
      } else {
        this.options = {
          alert: false,
          rowSelection: null
        }
        this.optionAlertShow = false
      }
    },
    batchDelete (id) {
      let ids = []
      if (this.BaseTool.String.isBlank(id)) {
        const length = this.selectedRows.length
        if (length === 0) {
          this.$message.info('请选择要删除的记录')
          return
        }
        ids = this.selectedRows.map(item => item.id)
      } else {
        ids = [id]
      }
      deletePurchasePaymentOrders(ids).then(res => {
        this.$message.info('删除成功')
        this.handleOk()
        this.$refs.table.clearSelected()
      })
    },
    handleAdd () {
      fetchPurchasePayment({ id: this.paymentId }).then(res => {
        const modal = this.$refs.baseModal
        modal.base(null, res.data)
      })
    },
    handleEdit (record) {
      fetchPurchasePayment({ id: this.paymentId }).then(res => {
        const modal = this.$refs.baseModal
        modal.base(record, res.data)
      })
    },
    handleView (record) {
      fetchPurchasePaymentOrder({ id: record.id }).then(res => {
        const modal = this.$refs.detailModal
        modal.base(res.data)
      })
    },
    handleOk () {
      this.$refs.table.refresh()
      this.$emit('ok', {})
    },
    onSelectChange (selectedRowKeys, selectedRows) {
      this.selectedRowKeys = selectedRowKeys
      this.selectedRows = selectedRows
    },
    resetSearchForm () {
      this.queryParam = {
        paymentId: this.paymentId
      }
      this.$refs.table.refresh(true)
    },
    doExport () {
      const parameter = {
        ...this.queryParam
      }
      exportPurchasePaymentOrder(parameter).then(file => {
        this.BaseTool.UPLOAD.downLoadExportExcel(file)
      })
    },
    handleEnter () {
      this.$refs.table.refresh(true)
    },
    handleCancel (values) {
      this.visible = false
      this.$emit('ok', values)
    }
  }
}
</script>
